WebAppLibrary/Controllers/BookController.cs
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using WebAppLibrary.Models.DAO;
using WebAppLibrary.Models.DataAccess;

namespace WebAppLibrary.Controllers
{
    public class BookController : Controller
    {

        DABook dataAccess;
        readonly string _connectionString;
        public BookController(IConfiguration configuration) {
            _connectionString = configuration.GetConnectionString("DefaultDB") ?? "";
            dataAccess= new DABook(_connectionString); 
        }

        // GET: BookController
        public ActionResult Index()
        {
            List<Book> lista = dataAccess.Read();
            return View(lista);
        }

        // GET: BookController/Details/5
        public ActionResult Details(int id)
        {
            Book book = dataAccess.ReadSingle(id);
            return View(book);
        }

        // GET: BookController/Create
        public ActionResult Create()
        {
            DAAuthor dataAccessBook = new DAAuthor(_connectionString);
            DAGenre dataAccessGenre = new DAGenre(_connectionString);
            ViewData["GenresList"] = new SelectList(dataAccessGenre.Read(), "Id", "Nombre");
            ViewData["AuthorsList"] = new SelectList(dataAccessBook.Read(), "Id", "FullName");
            return View();
        }

        // POST: BookController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Book book)
        {
            try
            {
                dataAccess.Create(book);    
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: BookController/Edit/5
        public ActionResult Edit(int id)
        {
            DAGenre dataAccessGenre = new DAGenre(_connectionString);
            DAAuthor dataAccessAuthor = new DAAuthor(_connectionString);
            ViewData["GenresList"] = new SelectList(dataAccessGenre.Read(), "Id", "Nombre");
            ViewData["AuthorsList"] = new SelectList(dataAccessAuthor.Read(), "Id", "FullName");
            Book book= dataAccess.ReadSingle(id);
            return View(book);
        }

        // POST: BookController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, Book book)
        {
            try
            {
                dataAccess.Update(book);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: BookController/Delete/5
        public ActionResult Delete(int id)
        {
            Book book = dataAccess.ReadSingle(id);
            return View(book);
        }

        // POST: BookController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                dataAccess.Delete(id);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

WebAppLibrary/Controllers/GenreController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.ModelBinding;
using System.Globalization;
using WebAppLibrary.Models.DataAccess;
using WebAppLibrary.Models.DAO;

namespace WebAppLibrary.Controllers
{
    public class GenreController : Controller
    {

        DAGenre daGenre;

        public GenreController(IConfiguration configuration)
        {
            string connectionString = configuration.GetConnectionString("DefaultDB") ?? "";
            daGenre = new DAGenre(connectionString);
        }

        // GET: GenreController
        public ActionResult Index()
        {
            List<Genre> genres = daGenre.Read();
            return View(genres);
        }

        // GET: GenreController/Details/5
        public ActionResult Details(int id)
        {
            Genre genre = daGenre.ReadSingle(id);
            return View(genre);
        }

        // GET: GenreController/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: GenreController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind("Nombre")] Genre genre)
        {
            try
            {
                daGenre.Create(genre);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: GenreController/Edit/5
        public ActionResult Edit(int id)
        {
            return View(daGenre.ReadSingle(id));
        }

        // POST: GenreController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(int id, Genre genre)
        {
            try
            {
                daGenre.Update(genre);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: GenreController/Delete/5
        public ActionResult Delete(int id)
        {
            return View(daGenre.ReadSingle(id));
        }

        // POST: GenreController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                daGenre.Delete(id);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

WebAppLibrary/Controllers/LoanController.cs
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using WebAppLibrary.Models.DAO;
using WebAppLibrary.Models.DataAccess;

namespace WebAppLibrary.Controllers
{
    public class LoanController : Controller
    {
        DALoan dataAccessLoan;
        private readonly string _connectionString;
        public LoanController(IConfiguration configuration) {
            _connectionString = configuration.GetConnectionString("DefaultDB") ?? "";
            dataAccessLoan = new DALoan(_connectionString);
        }

        // GET: LoanController
        public ActionResult Index()
        {
            List<Loan> loans = dataAccessLoan.Read();
            return View(loans);
        }

        // GET: LoanController/Details/5
        public ActionResult Details(int id)
        {
            Loan loan = dataAccessLoan.ReadSingle(id);
            return View(loan);
        }

        // GET: LoanController/Create
        public ActionResult Create()
        {
            DAUser dataAccessUser = new DAUser(_connectionString);
            DABook dataAccessBook = new DABook(_connectionString);
            ViewData["UsersList"] = new SelectList(dataAccessUser.Read(), "Id", "FullName");
            ViewData["BooksList"] = new SelectList(dataAccessBook.Read(), "Id", "Title");
            return View();
        }

        // POST: LoanController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Loan loan)
        {
            try
            {
                dataAccessLoan.Create(loan);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: LoanController/Edit/5
        public ActionResult Edit(int id)
        {
            DAUser dataAccessUser = new DAUser(_connectionString);
            DABook dataAccessBook = new DABook(_connectionString);
            ViewData["UsersList"] = new SelectList(dataAccessUser.Read(), "Id", "FullName");
            ViewData["BooksList"] = new SelectList(dataAccessBook.Read(), "Id", "Title");
            Loan loan = dataAccessLoan.ReadSingle(id);
            return View(loan);
        }

        // POST: LoanController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, Loan loan)
        {
            try
            {
                dataAccessLoan.Update(loan);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: LoanController/Delete/5
        public ActionResult Delete(int id)
        {
            Loan loan = dataAccessLoan.ReadSingle(id);
            return View(loan);
        }

        // POST: LoanController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                dataAccessLoan.Delete(id);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

WebAppLibrary/Controllers/UserController.cs
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using WebAppLibrary.Models.DataAccess;
using WebAppLibrary.Models.DAO;

namespace WebAppLibrary.Controllers
{
    public class UserController : Controller
    {
        private readonly string _connectionString;
        DAUser dataAccess;

        public UserController(IConfiguration configuration) {
            _connectionString = configuration.GetConnectionString("DefaultDB") ?? "";
            dataAccess = new DAUser(_connectionString);

        }
        // GET: UserController
        public ActionResult Index()
        {
            return View(dataAccess.Read());
        }

        // GET: UserController/Details/5
        public ActionResult Details(int id)
        {
            return View(dataAccess.ReadSingle(id));
        }

        // GET: UserController/Create
        public ActionResult Create()
        {
            return View();
        }

        // POST: UserController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(User usuario)
        {
            try
            {
                dataAccess.Create(usuario);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: UserController/Edit/5
        public ActionResult Edit(int id)
        {
            return View(dataAccess.ReadSingle(id));
        }

        // POST: UserController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(int id, User usuario)
        {
            try
            {
                dataAccess.Update(usuario);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }

        // GET: UserController/Delete/5
        public ActionResult Delete(int id)
        {
            return View(dataAccess.ReadSingle(id));
        }

        // POST: UserController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                dataAccess.Delete(id);
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

WebAppLibrary/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - WebAppLibrary</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <link rel="stylesheet" href="~/WebAppLibrary.styles.css" asp-append-version="true" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container-fluid">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Loan" asp-action="Index">Loans</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="User" asp-action="Index">Users</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Book" asp-action="Index">Books</a>
                        </li>
                        <li class="nav-item dropdown">
                            <!-- Agregamos la clase dropdown para crear un menú desplegable -->
                            <a class="nav-link dropdown-toggle text-dark" href="#" id="catalogsDropdown" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                Catalogs
                            </a>
                            <div class="dropdown-menu" aria-labelledby="catalogsDropdown">
                                <!-- Creamos el menú desplegable -->
                                <a class="dropdown-item" asp-area="" asp-controller="Author" asp-action="Index">Authors</a> <!-- Cada elemento del menú será un enlace normal -->
                                <a class="dropdown-item" asp-area="" asp-controller="Genre" asp-action="Index">Genres</a>
                                <a class="dropdown-item" asp-area="" asp-controller="Country" asp-action="Index">Countries</a>
                            </div>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            @*&copy; 2024 - WebAppLibrary - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>*@
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>